From 0c203f6b73df16ca4e7b6c72f21acd4f955ab6dc Mon Sep 17 00:00:00 2001
From: Rong Yan <rongyan236@foxmail.com>
Date: Mon, 20 Jul 2015 23:18:41 -0500
Subject: [PATCH 6/6] common/ppc/quant.c: POWER LE support in
 x264_quant_8x8_altivec() add macros GET_MULE() GET_MULO()

---
 common/ppc/quant.c | 15 +++++++++++----
 1 file changed, 11 insertions(+), 4 deletions(-)

diff --git a/common/ppc/quant.c b/common/ppc/quant.c
index 9382b5b..10b79f5 100644
--- a/common/ppc/quant.c
+++ b/common/ppc/quant.c
@@ -251,6 +251,13 @@ int x264_quant_8x8_altivec( int16_t dct[64], uint16_t mf[64], uint16_t bias[64]
     vec_st(dctv, 8*y, dct);                                          \
 }
 
+#ifdef WORDS_BIGENDIAN
+#define GET_MULE(a,b) vec_mule(a, (vec_s16_t)b)
+#define GET_MULO(a,b) vec_mulo(a, (vec_s16_t)b)
+#else
+#define GET_MULE(a,b) vec_mulo(a, (vec_s16_t)b)
+#define GET_MULO(a,b) vec_mule(a, (vec_s16_t)b)
+#endif
 #define DEQUANT_SHR()                                          \
 {                                                              \
     dctv = vec_ld(8*y, dct);                                   \
@@ -259,14 +266,14 @@ int x264_quant_8x8_altivec( int16_t dct[64], uint16_t mf[64], uint16_t bias[64]
     mf1v = vec_ld(16*y, dequant_mf[i_mf]);                     \
     mf2v = vec_ld(16+16*y, dequant_mf[i_mf]);                  \
                                                                \
-    multEvenvA = vec_mule(dct1v, (vec_s16_t)mf1v);             \
-    multOddvA = vec_mulo(dct1v, (vec_s16_t)mf1v);              \
+    multEvenvA = GET_MULE(dct1v, (vec_s16_t)mf1v);             \
+    multOddvA = GET_MULO(dct1v, (vec_s16_t)mf1v);              \
     temp1v = vec_add(vec_sl(multEvenvA, sixteenv), multOddvA); \
     temp1v = vec_add(temp1v, fv);                              \
     temp1v = vec_sra(temp1v, i_qbitsv);                        \
                                                                \
-    multEvenvA = vec_mule(dct2v, (vec_s16_t)mf2v);             \
-    multOddvA = vec_mulo(dct2v, (vec_s16_t)mf2v);              \
+    multEvenvA = GET_MULE(dct2v, (vec_s16_t)mf2v);             \
+    multOddvA = GET_MULO(dct2v, (vec_s16_t)mf2v);              \
     temp2v = vec_add(vec_sl(multEvenvA, sixteenv), multOddvA); \
     temp2v = vec_add(temp2v, fv);                              \
     temp2v = vec_sra(temp2v, i_qbitsv);                        \
-- 
2.1.4

